diff --git a/src/bin/pg_checksums/Makefile b/src/bin/pg_checksums/Makefile
index ac736b2260..3f946ee9d6 100644
--- a/src/bin/pg_checksums/Makefile
+++ b/src/bin/pg_checksums/Makefile
@@ -22,6 +22,8 @@ OBJS = \
 	$(WIN32RES) \
 	pg_checksums.o
 
+pg_checksums.o: CFLAGS += ${CFLAGS_UNROLL_LOOPS} ${CFLAGS_VECTORIZE}
+
 all: pg_checksums
 
 pg_checksums: $(OBJS) | submake-libpgport
diff --git a/src/bin/pg_upgrade/Makefile b/src/bin/pg_upgrade/Makefile
index bde91e2beb..b344b59da2 100644
--- a/src/bin/pg_upgrade/Makefile
+++ b/src/bin/pg_upgrade/Makefile
@@ -28,6 +28,8 @@ OBJS = \
 	util.o \
 	version.o
 
+file.o: CFLAGS += ${CFLAGS_UNROLL_LOOPS} ${CFLAGS_VECTORIZE}
+
 override CPPFLAGS := -I$(srcdir) -I$(libpq_srcdir) $(CPPFLAGS)
 LDFLAGS_INTERNAL += -L$(top_builddir)/src/fe_utils -lpgfeutils $(libpq_pgport)
 
